#!/usr/bin/env perl

#  zmbscap  - Zombie Scapper
#             http://zmbscap.sourceforge.net
#
# Copyright (C) Metaeye Security Group <contact@metaeye.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# we are sure this is there.
use Getopt::Std;

$ver     = "0.1";

# Required Libraries
# module => optional or not 0 or 1
%modules = ( "Net::Ping"   => 1,
             "Net::RawIP"  => 0,
             "IO::Socket"  => 0);

print "zmbscap -  Zombie Scapper v$ver.\n";
print "Copyright (C) Metaeye Security Group - http://zmbscap.sourceforge.net.\n\n";

for $module (keys %modules) {
    $opt=$modules{$module};
    unless (eval "require $module") {
        die  "[-] Error: could'nt load module $module: $@.\n" if $opt==0;
        warn "[-] Warning: could'nt load module $module.\n\n" if $opt==1;
    }
}

# Zombie Masters
# port => [name, protocol, cmdid, payload]

%zombie_masters = (
    27444 => [ "Trinoo"                    , "udp"  , "41072" , "d1e ads! 144"          ],
    18753 => [ "Shaft"                     , "udp"  , "41072" , "alive tijgv hi 5 2621" ],
    33720 => [ "Tribal Flood Network (TFN)", "icmp" , "567"   , "12345"                 ],
    12345 => [ "Stacheldraht v1"          , "udp"  , "3"     , "000"                   ],
    34555 => [ "Win Trinoo"                , "udp"  , "41072" , "d1e ads! 144"          ],
    6667  => [ "Win Trinoo"                , "udp"  , "41072" , "d1e ads! 144"          ],
    60001 => [ "Stacheldraht v2"           , "udp"  , "9001"  , "0000"                  ],
    12754 => [ "Mstream"                   , "icmp" , "1024"  , "> 1024 stream foo bar" ],
    15104 => [ "Mstream"                   , "icmp" , "1024"  , "> 1024 stream foo bar" ],
    39168 => [ "Trinity"                   , ""     , ""      , ""                      ],
    33270 => [ "Entitee"                   , ""     , ""      , ""                      ],
    #8080  => [ "TESTO1"                    , "icmp" , "111"   , "HOLA"                  ],
    #80  =>   [ "TESTO2"                    , "udp"  , "111"   , "LOLHOLA"               ],
    #21  =>   [ "TESTO3"                    , ""     , ""      , ""                      ],
);


# Program arguments 
getopts("h:i:n:t:",\%opt);


# Won't run wtout the host

if (!$opt{h}) {
    print "usage: zmbscap.pl -h <target> [-i <interface>] [-n <hits>] [-t <timeout>]\n";
    print "      <target> : ip address or hostname to scan.\n";
    print "      <interface> : interface to use for sending packets, default eth0.\n";
    print "      <hits> : no of times to send kill packets, default 1.\n\n";
    print "      <timeout> : communication timeout in seconds, default 3 seconds.\n\n";
    exit(1); 
}

$zombie_host = defined($opt{h}) ? $opt{h} : "127.0.0.1";
$interface   = defined($opt{i}) ? $opt{i} : "eth0";
$hits        = defined($opt{n}) ? $opt{n} : 1;
$timeout     = defined($opt{t}) ? $opt{t} : 3;

print "[+] Pinging host $zombie_host.";
print "\n";
eval {
    $zping=Net::Ping->new();
    if ($zping->ping($zombie_host,$timeout)) {
        print "[+] Host is up.\n";
    }else {
    print "[-] Host seems to be down.\n";
    }
};

if ($@) { print "[-] Failed: $@.\n";}


print "\n[+] Scanning host $zombie_host using interface $interface.\n\n";

for $zombie_master (keys %zombie_masters) {
    
    @zombie_parms=$zombie_masters{$zombie_master};
    $zport    = $zombie_master;
    $zname    = $zombie_parms[0][0];
    $zproto   = $zombie_parms[0][1];
    $zid      = $zombie_parms[0][2];
    $zpayload = $zombie_parms[0][3];
    $zsock = IO::Socket::INET->new(PeerAddr => $zombie_host,
                                   PeerPort => $zport,
                                   Proto    => "tcp",
                                   Timeout  => $timeout);
    if ( $zsock ) {
      print "[+] Detected possible infection: $zname.\n";       
      print "[+] Trying to kill $zname.\n";
      print kill_zombie_master($zombie_host,$zport,$zproto,$zid,$zpayload,$interface,$hits,$timeout) . ".\n"; 
      print "\n";
     }
}

sub kill_zombie_master {
     ($zombie_host,$zport,$zproto,$zid,$zpayload,$interface,$hits,$timeout) = @_;
     
     if( $zproto eq "" ) {
        return "[-] not possible to kill this.";
     }
     
     if( $zproto eq "icmp") {
       $zpacket = new Net::RawIP( { icmp => {} } );
       $zpacket->set( { ip => { daddr => $zombie_host } ,
                        icmp => { type => 0, id => unpack("S",pack("n",$zid)), data => $zpayload }
                    } );
       
       eval{ $zpacket->ethnew($interface) };
       if($@) { return "[-] Failed: invalid interface $interface"; } 
       
       eval { $zpacket->send($timeout,$hits) }; 
       if($@) { return "[-] Failed: $@"; } 
       
       return "[+] Kill packet sent $hits time(s)";
     }

     if( $zproto eq "udp") {
       $zpacket = new Net::RawIP( { udp => {} } );
       $zpacket->set( { ip =>  { daddr => $zombie_host }, 
                        udp => { dest  => $zport, data => $zpayload . unpack("S", pack("n",$zid )) } 
                    } );
       eval{ $zpacket->ethnew($interface) };
       if($@) { return "[-] Failed: invalid interface $interface"; } 
       
       eval { $zpacket->send($timeout,$hits) }; 
       if($@) { return "[-] Failed: $@"; } 
       
       return "[+] Kill packet sent $hits time(s)";
     }
}
